format PE GUI 4.0
entry start

include 'win32a.inc'

struct RESINFO
  size dd ?
  name db 12 dup ?
ends

section '.text' code readable executable
start:
  invoke GetCommandLine
  mov esi,eax
get:
  lodsb
  cmp al,'-'
  je get2
  cmp al,0
  je exit
  jmp get
get2:
  lodsb
  cmp al,'e'
  je get3
  cmp al,0
  je exit
  jmp get
get3:
  lodsb
  cmp al,' '
  je openlib
  cmp al,0
  je exit
  jmp get

openlib:
  invoke rsOpenLib,esi,0
  mov [lib],eax
  invoke rsLibNum,[lib]
  mov [libnum],eax
extract:
  invoke rsGetInfo,[lib],[counter],resinfo
  invoke rsLoad,[lib],[counter]
  mov [res],eax
  invoke _lcreat,resinfo.name,0
  mov [resfile],eax
  invoke _lwrite,[resfile],[res],[resinfo.size]
  invoke _lclose,[resfile]
  invoke ngiFree,[res]
  inc [counter]
  mov eax,[counter]
  cmp [libnum],eax
  jne extract
  invoke rsCloseLib,[lib]
exit:
  invoke ExitProcess,0

section '.data' data readable writeable
counter dd 0
libnum dd ?
lib dd ?
res dd ?
resfile dd ?
resinfo RESINFO

section '.idata' import data readable writeable
library kernel32,'KERNEL32.DLL',\
	ngi32,'NGI32.DLL'
import kernel32,\
       _lcreat,'_lcreat',\
       _lwrite,'_lwrite',\
       _lclose,'_lclose',\
       GetCommandLine,'GetCommandLineA',\
       ExitProcess,'ExitProcess'
import ngi32,\
       rsOpenLib,'rsOpenLib',\
       rsLibNum,'rsLibNum',\
       rsGetInfo,'rsGetInfo',\
       rsLoad,'rsLoad',\
       rsCloseLib,'rsCloseLib',\
       ngiFree,'ngiFree'
